#include <conio.h>
#include <stdio.h>
#include <string.h>

// definicja typu OSOBA
const int DL=10;
struct OSOBA
	{int Wzrost;
	 char Nazwisko[DL];
	};

//deklaracje uniwersalnych funkcji we/wy dla struktur typu OSOBA
void Pokaz_dane (OSOBA &Dana);
OSOBA Dane();
// deklaracje pomocniczych funkcji obsugujcych menu programu oraz komunikaty
 const int POZ=9;
 char Menu(const int ile, char *Polecenia[POZ]);
// deklaracje funkcji dla zdefiniowanej statycznej tablicy struktur jako listy nieuporzdkowanej
 const int N=5;
 int Wstaw(OSOBA*tab, OSOBA dane, int ktory, int &ile);
 int Usun(OSOBA*tab, int ktory, int &ile);
 int Wyswietl(OSOBA*tab, int ile);
 int Zapisdopliku(OSOBA*tab, int ile);
 int Odczytzpliku(OSOBA*tab, int& ile);

//przykadowa aplikacja wykorzystujca list nieuporzdkowan reprezentowan przez statyczn tablic struktur (tablist1.cpp)

char *Polecenia[POZ]={"Tablica OSOBA tab[N] - obsluga typu lista",
	" Nacisnij:",
	" 1 - aby wstawic element do listy osob",
	" 2 - aby usunac element z listy osob",
	" 3 - aby wyswietlic liste osob, ",
	" 4 - aby usunac liste osob",
	" 5 - aby zapisac do pliku",
	" 6 - aby odczytac z pliku",
	" Esc - aby zakonczyc prace."};

char *Stan[]=
	{"Tablica pelna",
	" Wstawiono poprawnie",
	" Zly numer do wstawienia",
	" Tablica pusta",
	" Usunieto poprawie",
	" Zly numer do usuwania",
	" Wyswietlono poprawnie",
	" Nie otwarto pliku do zapisu",
	" Dokonano zapisu do pliku",
	" Nie otwarto pliku do czytania",
	" Odczytano plik"};

 // funkcja oglnego przeznaczenia
 int Integer(char*);

void main(void)
{int ile=0, ktory,stan;
 OSOBA tab[N];
 char Co;
	 do
		{Co = Menu(POZ,Polecenia);
		 switch(Co)
			 {case '1' : OSOBA pom=Dane();
                                     ktory=Integer("\nPodaj indeks w tablicy: ");
                                     stan=Wstaw(tab,pom,ktory,ile);
                                     printf("%s\n",Stan[stan]);          break;
                          case '2' : ktory=Integer("\nPodaj indeks: ");
                                     stan=Usun(tab,ktory,ile);
                                     printf("\n%s\n",Stan[stan]);        break;
                          case '3' : stan=Wyswietl(tab,ile);
                                     printf("\n%s\n",Stan[stan]);        break;
                          case '4' : ile=0;                              break;
                          case '5' : stan=Zapisdopliku(tab,ile);
                                     printf("\n%s\n",Stan[stan]);        break;
                          case '6' : stan=Odczytzpliku(tab,ile);
                                     printf("\n%s\n",Stan[stan]);        break;
                          case 27  : printf("%s\n","\nKoniec programu"); break;
                          default  : printf("%s\n","\nZla opcja");
		}
		getch();
	 }while (Co !=27);
}

int Integer(char* s)
 { int ktory;
   printf("\n\n%s",s);
   scanf("%d",&ktory);
   return ktory; }

//definicje uniwersalnych funkcji we/wy dla struktur typu OSOBA
 OSOBA Dane()
 {char bufor[DL+2];
	OSOBA Nowy;
  bufor[0]=DL;
  Nowy.Wzrost=Integer("\nwzrost: ");
	printf("\nnazwisko: ");
  strcpy(Nowy.Nazwisko,cgets(bufor));
	return Nowy;
 }

 void Pokaz_dane(OSOBA &Dana)
  { printf("\n\nWzrost: %d\n", Dana.Wzrost);
    printf("Nazwisko:        %s\n", Dana.Nazwisko);
    printf("Nacisnij dowolny klawisz...\n"); 
		getch();
   }

// definicje pomocniczych funkcji obsugujcych menu programu oraz komunikaty
 char Menu(const int ile, char *Polecenia[])
   {clrscr();
    for (int i=0; i<ile;i++)
	printf("\n%s",Polecenia[i]);
		return getch();}


//definicje funkcji oslugujacych tablice struktur
int Wstaw(OSOBA* tab, OSOBA dane, int ktory,int &ile)
 {if (ile==N) return 0;
  if( ktory<0 || ktory>ile) return 2;
	for (int i=ile; i>ktory; i--) // zaoenia: 0<=ile<N i 0<=ktory<=ile
		 tab[i]=tab[i-1];
	tab[ktory]=dane;
  ile++;
  return 1;
 }

int Usun(OSOBA* tab, int ktory, int &ile)
 { if (ile==0) return 3;
   if (ktory<0 || ktory>=ile) return 5;
	 for (int i=ktory; i<ile-1; i++)  // zaoenia: 0<ile<=N i 0<=ktory<=ile-1
		tab[i]=tab[i+1];
	 ile--;
	 return 4;
 }

int Wyswietl(OSOBA* tab, int ile)
	{ if(ile==0) return 3;
		for (int i=0; i<ile;i++)
		 Pokaz_dane(tab[i]);		 //wykonaj czynno na elementach tablicy
		return 6;
	 }

int Zapisdopliku(OSOBA*tab, int ile)
 {

	 FILE *fptr;                      // wskaznik ptr do strumienia FILE
	 if( (fptr=fopen("fwrite.bin","wb"))==NULL )  // otwarcie pliku do
						 //zapisu w trybie binarnym
		return 7;
	 fwrite(tab, sizeof(OSOBA), ile, fptr);
	 fclose(fptr);                     // zamkniecie strumienia
	 return 8;
 }


int Odczytzpliku(OSOBA*tab, int& ile)
 {
	 FILE *fptr;
	 if( (fptr=fopen("fwrite.bin","rb"))==NULL )
		return 9;
	 ile=fread(tab,sizeof(OSOBA),N,fptr);   // czytanie pliku
	 fclose(fptr);                       // zamkniecie strumienia
	return 10;
 }

